<?php 
header('Content-Type: application/json');
set_time_limit(3300);
const PLX_ROOT = '../../../';
const PLX_CORE = PLX_ROOT .'core/';
define("L_SAVE_SUCCESSFUL",     "Enregistrement des données effectué avec succès");
define("L_SAVE_ERR",     "Erreur pendant l\'enregistrement des données");
if(!defined('PLX_CONFIG_PATH')) {
	include PLX_ROOT . 'config.php';
}
include_once PLX_CORE.'lib/config.php';
include_once PLX_CORE.'lib/class.plx.glob.php';
include_once PLX_CORE.'lib/class.plx.msg.php';
include_once PLX_CORE.'lib/class.plx.utils.php';
include_once PLX_CORE.'lib/class.plx.motor.php';
include_once PLX_CORE.'lib/class.plx.admin.php';
include_once PLX_CORE.'lib/class.plx.plugins.php';

$aResult = array();
$plxAdmin = plxAdmin::getInstance();
$plugin = "plxMapGeoIP"; // le plugin nécessaire pour les mails
$plxPlugin = $plxAdmin->plxPlugins->getInstance($plugin);
require(PLX_PLUGINS.$plugin."/lib/geoip2.phar"); // librairie pour geocoder les IP
use GeoIp2\Database\Reader;
$Geoip_data = $_POST["planning"]; // les dates selectionnées
$url_list = $_POST["url_list"]; // les url selectionnées 
$continent_code = $_POST["continent_code"]; // les url selectionnées 
$country_code = $_POST["country_code"]; // les url selectionnées 
$plxPlugin->setParam('Geoipdate', $Geoip_data, 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->setParam('url_list', $url_list, 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->setParam('continent_code', $continent_code, 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->setParam('country_code', $country_code, 'cdata'); // enregistrées dans les données de config du plugin
$plxPlugin->saveParams();
//////// calcul des données à afficher sur la carte openstreetmap
$log_url = $plxPlugin->getParam('log_url'); // le templace de l'url pour acceder aux fichiers log
$exclude_IPs = $plxPlugin->getParam('exclude_IPs'); // les IP à exclure
$bot_list = $plxPlugin->getParam('bot_list'); // les bots à rechercher et à eliminer
$mapcluster_radius = $plxPlugin->getParam('mapcluster_radius'); // le rayon du cluster group sur la carte open map street
$dbmmdb = PLX_ROOT.$plxPlugin->getParam('data_mmdb');  // la base mmdb avec son path 
$goacces_crawlers = $plxPlugin->getParam('goacces_crawlers');
require (PLX_ROOT.'plugins/plxMapGeoIP/lib/Kassner/autoload.php');
$parser = new \Kassner\LogParser\LogParser();
$laxParser = new \Kassner\LogParser\LogParser();
$parser->setFormat($plxPlugin->getParam('regex_url'));
$laxParser->setFormat($plxPlugin->getParam('regex_url'));
$laxParser->addPattern('%r', '(?P<request>.+)');
$openstreetmap_data = "";
$iplistfinal = array();
$datminfinal = array();
$ippagsfinal = array();
$array_list_dates = array();
$array_list_visiteurs = array();
$array_globale_iplist = array();
$array_globale_datmin = array();
$array_globale_ippags = array();
$iplist = array();
$iplistuseragent = array();
$icon_color = array();
$ippags = array();
$datmin = array();
$firstdate = "2099-12-31";
$lastdate = "1900-01-01";
$nbvisites = 0;

$ipblacklist = preg_split('/\n|\r/', $exclude_IPs, -1, PREG_SPLIT_NO_EMPTY); // les IP à exclure telles que enregistrées dans la conf du plugin
$botlist = preg_split('/\n|\r/', $bot_list, -1, PREG_SPLIT_NO_EMPTY); // les bots à rechercher (présence du string dans la ligne de log)
$logdate = explode (",", $plxPlugin->getparam('Geoipdate')); // on recupere les dates de log saisies 

// calcul de la liste des url du site 

$url_list = $plxPlugin->getParam('url_list');
if ($url_list == "") {
	$xml = simplexml_load_file("../../../sitemap.xml");
	$listurls = array();
	foreach($xml->children() as $key => $children) {
		$url = parse_url($children->loc, PHP_URL_PATH);
		$listurls[] = $url;
	}
	$url_list = implode("\n", $listurls);
	$plxPlugin->setParam('url_list', $url_list, 'cdata'); // enregistrées dans les données de config du plugin
	$plxPlugin->saveParams();
}
else {
	if ($url_list == "/accueil") {$url_list = $url_list . "\n/";}
	$plxPlugin->setParam('url_list', $url_list, 'cdata'); // enregistrées dans les données de config du plugin
	$plxPlugin->saveParams();

	$listurls = explode("\n", $url_list);
};
//$listurls =array();
//$listurls[] .= "/circuits";
// fin du calcul des url du site
$Windows = 0;
$Macintosh = 0;
$iPhone = 0;
$iPad = 0;
$Android = 0;
$Linux_x86_64 = 0;
$node_fetch = 0;
$Analyse = 0;
$log_lines_csv = PLX_PLUGINS.$plugin."/data/access.csv"; // le fichier contient les données uniquement pour les lignes bots
$log_lines_error_txt = PLX_PLUGINS.$plugin."/data/parsingerror.txt"; // le fichier contient les données uniquement pour les lignes bots
try {
	if(file_exists($log_lines_csv)) {
		if (!unlink($log_lines_csv)) 
		throw new Exception($log_lines_csv . ' File not available');
	}
	if(!$handle_log_lines_csv = fopen ($log_lines_csv, 'x'))
		throw new Exception($log_lines_csv . ' File not handle');
}
catch(Exception $e) {
	$aResult['fail'] = $e->getMessage();
	echo json_encode($aResult);
	exit;		
	}
try {
	if(file_exists($log_lines_error_txt)) {
		if (!unlink($log_lines_error_txt)) 
		throw new Exception($log_lines_error_txt . ' File not available');
	}
	if(!$handle_log_lines_error_txt = fopen ($log_lines_error_txt, 'x'))
		throw new Exception($log_lines_error_txt . ' File not handle');
}
catch(Exception $e) {
	$aResult['fail'] = $e->getMessage();
	echo json_encode($aResult);
	exit;		
	}
// debut de traitement pour une log (une date sélectionnée)
$nbligparserror = 0;
$nbligparse = 0;

foreach($logdate as $datlog) 
{
	$dt = DateTime::createFromFormat("m-d-Y", $datlog);
	$dat = $dt->format('Y-m-d');
	if ($dat < $firstdate) $firstdate = $dat;
	if ($dat > $lastdate) $lastdate = $dat;
	$dd = $dt->format("d");
	$mm = $dt->format("m");
	$yy = $dt->format("y");
	$yyyy = $dt->format("Y");
	$datAAMMJJ = $dt->format("Y-m-d");
	$datelogrec = $dt->format("d/M/Y");
	$logfile = "https://".$_POST['passok']."@".$plxPlugin->getParam('log_url'); // recup de la description de l'URL d'une log depuis la config du plugin
	$logfile = str_replace(['%d%','%m%', '%y%', '%Y%'],[$dd, $mm, $yy, $yyyy],$logfile);
	try{
		if (!$handle = gzopen($logfile,'r')){
				throw new Exception('failed : log file access error ');
			}else{
			}
		}catch(Exception $e){
			$aResult['fail'] = $e->getMessage();
			echo json_encode($aResult);
			exit;
		}
	while (!feof($handle)) { // pour chaque line du fichier log
		$logLine = fgets($handle); 
		$nbligparse += 1;
		try {
			try {
				$entry = $parser->parse($logLine);
			} catch (Exception $e) {
				$entry = $laxParser->parse($logLine);
			}
		} catch (Exception $e) {
			$nbligparserror += 1;
			if ($nbligparserror < 100) { // uniquement les 100 1eres lignes en erreur
				try{
					if ((fwrite($handle_log_lines_error_txt, $logLine )) === false){
						throw new Exception('failed : log line error file');
					}else{
					}
				}catch(Exception $e){
					$aResult['fail'] = $e->getMessage();
					echo json_encode($aResult);
					exit;
				}
			}
			continue;
		}
		$ip = $entry->host;
		$logdate = $entry->time;
		$date = DateTime::createFromFormat('j/M/Y:H:i:sO', $logdate);
		$date = $date->format('Y-m-d H:i:s');

		$botfound = false;
		$botstring = "";
		foreach($botlist as $botstring)
		{
			if (!(strpos($entry->HeaderUserAgent, $botstring) === false)) {$botfound = true; $botline = $botstring;};
		}
		$logline_select = true;
		if ($goacces_crawlers == "--crawlers-only" && $botfound == false) {$logline_select = false;};
		if ($goacces_crawlers == "--ignore-crawlers" && $botfound == true) {$logline_select = false;};
		if  ((in_array($ip, $ipblacklist) ===  false) && ($logline_select ===  true)) // IP non exclue et pas de bot
		{
			$urlmatch = false; // init
			$key = 0;
			foreach($listurls as $geturl) // boucle pour la recherche des urls du site dans la ligne de log
			{
				if (!(strpos($entry->request, "GET " . $geturl . " ") === false)) // recherche dans ligne de log de la sequence GET /xxxx
				{
					$urlmatch = $key;
					$url_csv = $geturl;
					break; 
				}
			$key++;
			}	
			if ($urlmatch !== false) // on retient cette log line
			{

				if ($botfound) {
					$date_time = strtotime ($date);
					$logline_csv = $url_csv . ";" . $ip . ";" . $botline . ";" . $date . ";" . $date_time . ";" . str_replace(";", "|", $logLine);
					try{
						if ((fwrite($handle_log_lines_csv, $logline_csv )) === false){
							throw new Exception('failed : access csv file');
						}else{
						}
					}catch(Exception $e){
						$aResult['fail'] = $e->getMessage();
						echo json_encode($aResult);
						exit;
					}
				}
				else 
				{
					$i = array_search ($ip.$entry->HeaderUserAgent, $iplistuseragent, true); // recherche de l'IP-UserAgent dans la liste des IP-userAgent déjà reconnues comme bonnes
					if ($i === false) // c'est la 1ere fois que l'on traite cette IP-UserAgent dans cette log
					{
						$iplistuseragent[] = $ip.$entry->HeaderUserAgent; // on ajoute le couple IP-UserAgent 
						$iplist[] = $ip; // on ajoute l'IP dans la liste (cette IP est peut-être déjà présent à cause d'un autre userAgent)
						
						$datmin[] = $date;
						$ippags[] = array($ip => array($geturl => 1)); // // on ajoute l'IP dans ce  tableau (cette IP est peut-être déjà présent à cause d'un autre userAgent)
						// comptage des devices
						$Analyse++;
						$color = "none";
						if (strpos($entry->HeaderUserAgent, "Windows") !== false) {$Windows++; $color = "blue";};
						if (strpos($entry->HeaderUserAgent, "Macintosh") !== false) {$Macintosh++; $color = "orange";};
						if (strpos($entry->HeaderUserAgent, "iPhone") !== false) {$iPhone++; $color = "red";};
						if (strpos($entry->HeaderUserAgent, "iPad") !== false) {$iPad++; $color = "yellow";};
						if (strpos($entry->HeaderUserAgent, "Android") !== false) {$Android++; $color = "green";};
						if (strpos($entry->HeaderUserAgent, "Linux x86_64") !== false) {$Linux_x86_64++; $color = "grey";};
						if (strpos($entry->HeaderUserAgent, "node-fetch") !== false) {$node_fetch++; $color = "black";};
						$icon_color[] = $color;
					}
					else // on a deja vu ce couple IP-useragent dans cette log
					{
						$ipurls = $ippags[$i][$ip]; // on recupère le tableau des Url pour ce  couple IP-useragent
						if (isset ($ipurls[$geturl])) // url de la page requetée / GET dejà trouvée dans cette log pour ce  couple IP-useragent
						{
							$ippag = $ipurls[$geturl] + 0; // on n'incrémente pas le nb de requetes de façon à avoir le nb de visiteurs
							$ipurls = array_replace($ipurls, array($geturl => $ippag));	// on remplace dans le tableau des Url de ce  couple IP-useragent
							$ippags = array_replace($ippags, array($i => array($ip => $ipurls)));	// on remplace le tableau des Url dans le tableau des ip-url de ce  couple IP-useragent
						}
						else 
						{
							$ippag = 1; // on initialise le nb de requetes 
							$ipurls = array_replace($ipurls, array($geturl => $ippag));	// on ajoute cette url dans le tableau des Url de ce  couple IP-useragent
							$ippags = array_replace($ippags, array($i => array($ip => $ipurls))); // on remplace le tableau des Url dans le tableau des ip-url de ce  couple IP-useragent	
						}
						$datmin = array_replace($datmin, array($i => min($datmin[$i], $date))); // pour avoir la date de la 1ere requete de cette IP dans la journée
					};
				};
			};
		};
	};
	fclose($handle);
	$dt = DateTime::createFromFormat("m-d-Y", $datlog);
	$datlog = $dt->format('d-m-y');
	$array_globale_iplist[] = [$datlog => $iplist];
	$array_globale_datmin[] = [$datlog => $datmin];
	$array_globale_ippags[] = [$datlog => $ippags];
	// on merge en vue d'obtenir la liste finale 
	//$iplistfinal = array_merge ($iplistfinal, $iplist); 
	//$datminfinal = array_merge ($datminfinal, $datmin);
	//$ippagsfinal = array_merge ($ippagsfinal, $ippags);
	$array_list_dates[] = $datlog ;
	//$array_list_visiteurs[] = count($iplist) ;
	$plxPlugin->setParam('iplist', implode(",", $iplist) , 'cdata');

	// on reinitialise la liste des IP et les dates pour la  log suivante
	$iplistuseragent = array();
	$iplist = array();
	$datmin = array();
	$ippags = array();
}; 
// end of boucle pour chaque date sélectionnée (une pour chaque fichier log)

// pour chaque IP de la liste on recherche les infos ville, latitude et longitude
// on en profite pour denombrer les requetes en echec (IP not found dans la base)
$key = 0;
$villes = array();
$ipinconnu = 0;
$nbdouteux = 0;
$continent_code = $plxPlugin->getParam('continent_code');
$country_code = $plxPlugin->getParam('country_code');

try{
	if (!$reader = new Reader($dbmmdb)){
		throw new Exception('failed : access mmdb file');
	}else{
	}
}catch(Exception $e){
	$aResult['fail'] = $e->getMessage();
	echo json_encode($aResult);
	exit;
}

$i = 0;
$nbvisitorsurls = array();
foreach ($array_list_dates as $datlog) {
	$iplistfinal = $array_globale_iplist[$i][$datlog];
	$datminfinal = $array_globale_datmin[$i][$datlog];
	$ippagsfinal = $array_globale_ippags[$i][$datlog];
	$key = 0;
	$nbvisiteursDay = 0;
	foreach ($iplistfinal as $ip) // boucle pour chaque IP trouvée dans le fichier 
	// une IP requetant sur N jours est présente N fois ==> N visites
	{	
		try {
			$record = $reader->city($ip);
		$record = $reader->city($ip);
		if ((((!empty($continent_code)) && ($record->continent->code == $continent_code))
			|| (empty($continent_code)))
		&& 
			(((!empty($country_code)) && ($record->country->isoCode  == $country_code))
			|| (empty($country_code))))
		{
								
			// calcul des visitors par url
			$ipurls = $ippagsfinal[$key][$ip]; // le tableau des url visités pour cette ip
			foreach ($ipurls as $geturl => $nbvisitorsurl) {

				if (isset ($nbvisitorsurls[$geturl])) // url déjà dans le tableau
				{
					$nbvisitorsurl = $nbvisitorsurls[$geturl];
					$nbvisitorsurls = array_replace($nbvisitorsurls, array($geturl => $nbvisitorsurl + 1));	
				}
				else {
					$nbvisitorsurls = array_replace($nbvisitorsurls, array($geturl => 1));	// on ajoute cette url dans le tableau des Url de ce  couple IP-useragent
				}
			}
			$openstreetmap_data .= $record->location->latitude . ','. $record->location->longitude;
			$ville = $record->city->name;
			if ($ville == "") 
			{
			$nbdouteux++;
			$ville = "lat " .  $record->location->latitude . " long " . $record->location->longitude;
			};
			$nbvisites++;
			$nbvisiteursDay++;
			$ville = $record->city->name;
			$ipurls = $ippagsfinal[$key][$ip];

			$output = implode(' ', array_map(
				function ($v, $k) { return sprintf("%s='%s'", $k, $v); },
				$ipurls,
				array_keys($ipurls)
				));
			$villes [] = $ville;
			$bulle = $ip . " " . $ville . " " . $datminfinal[$key] . " " . str_replace("'", " ", $output);
			$infos[] = $bulle;
			$openstreetmap_data .= ',' . $bulle . ','.$icon_color[$key]."\r";;
		}
		} catch (Exception $e)
			{
			$ipinconnu++;
			}
	$key++;
	};
$array_list_visiteurs[] = $nbvisiteursDay ;
$i++;
};
$tabresult_file = PLX_ROOT.$plxPlugin->getParam('data_dir'). "/tabresult.php";
$tabresult = $nbvisites . ',' . $nbdouteux . ',' . $ipinconnu;
$plxPlugin->setParam('sel_dates', $firstdate. ',' . $lastdate, 'cdata');
$plxPlugin->setParam('tabresult', $tabresult, 'cdata');
$devices = $Windows . "," . $Macintosh . "," . $Android . "," . $iPhone . "," . $iPad . "," . $Analyse . "," . $Linux_x86_64 . " ," . $node_fetch;
$plxPlugin->setParam('devices', $devices, 'cdata');
$plxPlugin->setParam('list_dates', implode(",", $array_list_dates) , 'cdata');
arsort($nbvisitorsurls);
$plxPlugin->setParam('nbvisitorsurls', implode(",", array_values($nbvisitorsurls)), 'cdata');
$plxPlugin->setParam('listvisitorsurls', implode(",", array_keys($nbvisitorsurls)), 'cdata');
$plxPlugin->setParam('list_visiteurs', implode(",", $array_list_visiteurs), 'cdata');
$plxPlugin->saveParams();


// on ecrit le resultat dans les données de la carte 1 du plugin plxOpenStreetMap pour permettre l'affichage de la  carte
$plugin = "plxOpenStreetMap"; // le plugin nécessaire
$plxPlugin = $plxAdmin->plxPlugins->getInstance($plugin); 
$plxPlugin->setParam('1_points', rtrim($openstreetmap_data, "\r\n"), 'cdata'); // c'est la carte n° 1 qui est utilisée; elle doit être créé préalablement dans la config du plugin 
try{
	if (!$plxPlugin->saveParams()){
		throw new Exception('failed : Store result in config.xml');
	}else{
	}
}catch(Exception $e){
	$aResult['fail'] = $e->getMessage();
	echo json_encode($aResult);
	exit;
}
$aResult['result'] = "OK";
$message = " dont aucune erreur de parsing"; 
if ($nbligparserror > 0) {$message = " dont " . $nbligparserror . " avec erreur de parsing : consultez " . $log_lines_error_txt;}
$aResult['message'] = $nbligparse . " lignes de log lues " . $message;
echo json_encode($aResult);
